## in-toto-golang 0.9.0+ds

=== Makefile ===
# Common Certificate Attributes
TRUST_DOMAIN_FQDN := example.com
DEFAULT_BITS := 2048
DEFAULT_MD := sha512
ORGANIZATIONAL_UNIT := example
ORGANIZATION := example
ROOT_DAYS := 3650
INTERMEDIATE_DAYS := 3650
LEAF_DAYS := 1
GOOS ?= $(shell go env GOOS)
GOARCH ?= $(shell go env GOARCH)


# Template Locations
OPENSSL_TMPL := ./certs/openssl.cnf.tmpl
LAYOUT_TMPL := ./certs/layout.tmpl

build: modules
	@mkdir -p bin
	GOOS=$(GOOS) GOARCH=$(GOARCH) CGO_ENABLED=0 go build \
	-o ./bin/in-toto main.go

modules:
	@go mod tidy

clean: clean-certs clean-test-files spiffe-infra-down
	@rm -rf ./bin

clean-certs:
	@rm -rf ./certs/*.pem ./certs/*.srl ./certs/*.cnf

clean-test-files:
	@rm -rf ./test/tmp
	@rm -rf ./untar.link
	@rm -rf ./.srl

test: go-test test-verify test-spiffe-verify

go-test:
	@go test ./...

test-sign: build generate_layout
	# Running test-sign
	cd ./test/tmp; ../../bin/in-toto sign -f ./test.layout -k ../../certs/example.com.layout.key.pem -o ./signed.layout

test-record: build generate_layout
    # Running record start
	cd ./test/tmp; ../../bin/in-toto record start -n write-code -c ../../certs/example.com.write-code.cert.pem -k ../../certs/example.com.write-code.key.pem -d .
    # Record running step
	cd ./test/tmp; echo goodbye > foo.py
	# Running record stop
	cd ./test/tmp; ../../bin/in-toto record stop -n write-code -c ../../certs/example.com.write-code.cert.pem -p foo.py -k ../../certs/example.com.write-code.key.pem -d .

test-run: build generate_layout
	# Running write code step
	@./bin/in-toto run -n write-code -c ./certs/example.com.write-code.cert.pem -k ./certs/example.com.write-code.key.pem -p ./test/tmp/foo.py -d ./test/tmp -l ./test/tmp/ -- /bin/sh -c "echo hello > ./test/tmp/foo.py"
	# Running package step
	@./bin/in-toto run -n package -c ./certs/example.com.package.cert.pem -k ./certs/example.com.package.key.pem -m ./test/tmp/foo.py -p ./test/tmp/foo.tar.gz -d ./test/tmp -l ./test/tmp/ -- tar zcvf ./test/tmp/foo.tar.gz ./test/tmp/foo.py

test-verify: test-sign test-run
	# Running test verify
	cd ./test/tmp; ../../bin/in-toto verify -l ./signed.layout -k ../../certs/example.com.layout.cert.pem -i ../../certs/example.com.intermediate.cert.pem -d .

test-spiffe-run: test-spiffe-sign
	# Running write code step
	docker exec -u 1000 -w /test/tmp -it intoto-runner in-toto run --spiffe-workload-api-path unix:///run/spire/sockets/agent.sock -n write-code -p foo.py -d . -- sh -c "echo hello > foo.py"
	# Running package step
	docker exec -u 1001 -w /test/tmp -it intoto-runner in-toto run --spiffe-workload-api-path unix:///run/spire/sockets/agent.sock -n package -m foo.py -p foo.tar.gz -d . -- tar zcvf foo.tar.gz foo.py

test-spiffe-verify: test-spiffe-sign test-spiffe-run
	# Running test verify
	docker exec -it -w /test/tmp intoto-runner /bin/in-toto verify -l ./spiffe.signed.layout -k ./layout-svid.pem -d .

test-spiffe-sign: build spiffe-test-generate-layout
	docker exec -it -w /test/tmp intoto-runner /bin/in-toto sign -f ./spiffe.test.layout -k ./layout-key.pem -o ./spiffe.signed.layout

spiffe-test-generate-layout: spiffe-infra-up
	# Get key layout from the root cert
	$(eval rootca := $(shell ./bin/in-toto key layout ./test/tmp/layout-bundle.pem | sed -e 's/\\n/\\\\n/g'))
	cat $(LAYOUT_TMPL) | sed -e 's#{{ROOTCA}}#$(rootca)#' > ./test/tmp/spiffe.test.layout
	docker-compose -f ./test-infra/docker-compose.yaml up -d intoto-runner
	sleep 5 # sleep to ensure the intoto-runner is fully up and connected to spire

spiffe-infra-up: build
	@mkdir -p ./test/tmp
	@chmod 777 ./test/tmp
	./test-infra/infra-up.sh
	./test-infra/mint-cert.sh layout

spiffe-infra-down:
	./test-infra/infra-down.sh

generate_layout: build leaf_certs
	@mkdir -p ./test/tmp
	# get key layout from the root cert
	$(eval rootca := $(shell ./bin/in-toto key layout ./certs/root.cert.pem | sed -e 's/\\n/\\\\n/g'))
	cat $(LAYOUT_TMPL) | sed -e 's#{{ROOTCA}}#$(rootca)#' > ./test/tmp/test.layout

root-cert:
	# Generate root cert openssl conf file
	$(call generate_openssl_conf,root)

	# Create Root Key
	@openssl genrsa -out ./certs/root.key.pem

	# Create Root Cert
	@openssl req -subj "/C=/ST=/L=/O=$(ORGANIZATION)/OU=$(ORGANIZATIONAL_UNIT)CN=root/" -days $(ROOT_DAYS) -x509 -new \
	-key "./certs/root.key.pem" -out "./certs/root.cert.pem" \
	-config ./certs/$(TRUST_DOMAIN_FQDN).root.openssl.cnf \
	-extensions v3-root

intermediate_cert: root-cert
	# Generate intermediate cert openssl conf file
	$(call generate_openssl_conf,intermediate)

	# Create intermediate key
	@openssl genrsa -out ./certs/$(TRUST_DOMAIN_FQDN).intermediate.key.pem

	# Generate intermediate CSR
	@openssl req -subj "/C=/ST=/L=/O=$(ORGANIZATION)/OU=$(ORGANIZATIONAL_UNIT)CN=$(TRUST_DOMAIN_FQDN)" -new \
	-key ./certs/$(TRUST_DOMAIN_FQDN).intermediate.key.pem \
	-out ./certs/$(TRUST_DOMAIN_FQDN).intermediate.csr.pem \
	-config ./certs/$(TRUST_DOMAIN_FQDN).intermediate.openssl.cnf \
	-extensions v3-intermediate

	# Sign Intermediate CSR Using Root Certificate
	@openssl x509 -days $(INTERMEDIATE_DAYS) -req \
	-CAcreateserial \
	-CA ./certs/root.cert.pem \
	-CAkey ./certs/root.key.pem \
	-in ./certs/$(TRUST_DOMAIN_FQDN).intermediate.csr.pem \
	-out ./certs/$(TRUST_DOMAIN_FQDN).intermediate.cert.pem \
	-extfile ./certs/$(TRUST_DOMAIN_FQDN).intermediate.openssl.cnf \
	-extensions v3-intermediate

	# Verify intermediate cert was signed by root cert
	@openssl verify -CAfile ./certs/root.cert.pem ./certs/$(TRUST_DOMAIN_FQDN).intermediate.cert.pem

leaf_certs: intermediate_cert
	$(call generate_leaf_cert,layout)
	$(call generate_leaf_cert,write-code)
	$(call generate_leaf_cert,package)

define generate_leaf_cert
	# Generate leaf cert openssl conf file
	$(call generate_openssl_conf,$(1))

	# Generate leaf signing key
	@openssl genrsa -out ./certs/$(TRUST_DOMAIN_FQDN).$(1).key.pem

	# Generate leaf CSR
	openssl req -new \
	-key ./certs/$(TRUST_DOMAIN_FQDN).$(1).key.pem \
	-out ./certs/$(TRUST_DOMAIN_FQDN).$(1).csr.pem \
	-config ./certs/$(TRUST_DOMAIN_FQDN).$(1).openssl.cnf \
	-extensions v3-leaf

	# Sign leaf CSR Using intermediate Certificate
	@openssl x509 -days $(LEAF_DAYS) -req \
	-CAcreateserial \
	-CA ./certs/$(TRUST_DOMAIN_FQDN).intermediate.cert.pem \
	-CAkey ./certs/$(TRUST_DOMAIN_FQDN).intermediate.key.pem \
	-in ./certs/$(TRUST_DOMAIN_FQDN).$(1).csr.pem \
	-out ./certs/$(TRUST_DOMAIN_FQDN).$(1).cert.pem \
	-extfile ./certs/$(TRUST_DOMAIN_FQDN).$(1).openssl.cnf \
	-extensions v3-leaf

	# Create cert bundle for trust domain
	cat ./certs/root.cert.pem ./certs/$(TRUST_DOMAIN_FQDN).intermediate.cert.pem > ./certs/$(TRUST_DOMAIN_FQDN).bundle.cert.pem

	# Verify leaf cert chain
	@openssl verify -CAfile ./certs/$(TRUST_DOMAIN_FQDN).bundle.cert.pem ./certs/$(TRUST_DOMAIN_FQDN).$(1).cert.pem
endef

define generate_openssl_conf
	@cat $(OPENSSL_TMPL) | sed -e 's/{{TRUST_DOMAIN_FQDN}}/$(TRUST_DOMAIN_FQDN)/'  | \
	sed -e 's/{{ORGANIZATIONAL_UNIT}}/$(ORGANIZATIONAL_UNIT)/' | \
	sed -e 's/{{ORGANIZATION}}/$(ORGANIZATION)/' | \
	sed -e 's/{{DEFUALT_BITS}}/$(DEFAULT_BITS)/' | \
	sed -e 's/{{DEFAULT_MD}}/$(DEFAULT_MD)/' | \
	sed -e 's/{{SPIFFE_PATH}}/$(1)/' > certs/$(TRUST_DOMAIN_FQDN).$(1).openssl.cnf
endef

.PHONY: help
all: help
help: Makefile
	@echo
	@echo " Choose a command run in in-toto-golang:"
	@echo
	@sed -n 's/^##//p' $< | column -t -s ':' |  sed -e 's/^/ /'
	@echo

=== debian/changelog ===
in-toto-golang (0.9.0+ds-5) unstable; urgency=medium

  [ Simon Josefsson ]
  * Modernize Salsa CI
  * Use watch v5
  * Drop Rules-Requires-Root: no
  * Standards-Version: 4.7.3
  * Use dh-sequence-golang
  * Bump debian/* copyright years

  [ Chris Lamb ]
  * Fix reproducibility (Closes: #1121801)

 -- Simon Josefsson <simon@josefsson.org>  Mon, 29 Dec 2025 00:43:30 +0100

in-toto-golang (0.9.0+ds-4) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Standards-Version: 4.7.2.
  * Add Static-Built-Using.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 16 Aug 2025 14:07:46 +0200

in-toto-golang (0.9.0+ds-3) unstable; urgency=medium

  * Fix autopkgtest failures by avoiding alterations to a reference
    tarball for the test suite

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 26 Jun 2024 20:36:39 -0400

in-toto-golang (0.9.0+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 16 May 2024 08:14:10 -0400

in-toto-golang (0.9.0+ds-1) experimental; urgency=medium

  * Initial release (Closes: #1060818)

 -- Simon Josefsson <simon@josefsson.org>  Fri, 19 Jan 2024 10:09:34 +0100

=== debian/control ===
Source: in-toto-golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-google-go-cmp-dev,
 golang-github-secure-systems-lab-go-securesystemslib-dev,
 golang-github-shibumi-go-pathspec-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spiffe-go-spiffe-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-sys-dev,
 golang-google-grpc-dev,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/in-toto-golang
Vcs-Git: https://salsa.debian.org/go-team/packages/in-toto-golang.git
Homepage: https://github.com/in-toto/in-toto-golang
XS-Go-Import-Path: github.com/in-toto/in-toto-golang

Package: in-toto-golang
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: software supply chain integrity framework in-toto for Go
 in-toto provides tools both for software developers to authenticate operations
 in the supply chain, as well as for end-users to verify the authentication
 trail when installing a software product.
 .
 This package contains the "in-toto-golang" command-line tool.

Package: golang-github-in-toto-in-toto-golang-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-google-go-cmp-dev,
 golang-github-secure-systems-lab-go-securesystemslib-dev,
 golang-github-shibumi-go-pathspec-dev,
 golang-github-spf13-cobra-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-sys-dev,
 golang-google-grpc-dev,
 ${misc:Depends},
Description: software supply chain integrity framework in-toto for Go (library)
 in-toto provides tools both for software developers to authenticate operations
 in the supply chain, as well as for end-users to verify the authentication
 trail when installing a software product.
 .
 This package contains the Go library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := test

%:
	dh $@ --builddirectory=_build --buildsystem=golang

# fixes autopkgtest. The foo.tar.gz must not be altered because the
# tests compare expected checksums in generated jwt tokens
override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -Xfoo.tar.gz

execute_after_dh_auto_build:
# === RUN   TestInTotoVerifyPass/verifying_with_only_DSSE_metadata
#     verifylib_test.go:95: layout has expired on '2023-06-03 13:25:20 +0000 UTC'
# --- FAIL: TestInTotoVerifyPass (0.04s)
#     --- PASS: TestInTotoVerifyPass/metablock_layout (0.02s)
#     --- PASS: TestInTotoVerifyPass/DSSE_layout (0.02s)
#     --- FAIL: TestInTotoVerifyPass/verifying_with_only_DSSE_metadata (0.00s)
# === RUN   TestGetSummaryLink
	rm -f _build/src/github.com/in-toto/in-toto-golang/in_toto/verifylib_test.go

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/in-toto/in-toto-golang/releases?per_page=50
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
Dversionmangle: auto
Filenamemangle: s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%
Repacksuffix: +ds
Searchmode: plain
